#ifndef COMM_H
#define COMM_H

#include "config.h"
#include <string>
#include <utility>
#include <vector>
#include <ctime>
#include <gnome.h>
#include <libgnome/gnome-i18n.h>
#include "common.h"

//#include <locale.h>
//#define LC_TIME 2
//extern char *setlocale(int, const char*);

#include "article.h"
#include "connection.h"
#include "session.h"
#include "unread-confs.h"
#include "get_membership_list_q.h"
#include "create_text_q.h"
#include "uplink.h"


class Comm 
{
public:
    Comm();
    int login(string hostname, string username, string password); 
    void logout();
    vector< longstringpair > getConferences(string str="", bool pers=true, bool conf=true);
    bool joinConference(unsigned int conference_id);
    bool leaveConference(unsigned int conference_id);
    Article getNextUnreadArticle();
    bool setUnread(unsigned long int number);
    long int getUnread();
    long int getNumberOfArticles();
    bool sendArticle(Article article);
    vector< longstringpair > getMemberConferences();
    bool changeConference(unsigned int conference_id);
    longstringpair getNextConference();
    struct std::tm getTime();
    string getTimeString();
    unsigned long int getUserId();
    void setStatus(bool status_in);
    bool getStatus();
  
private:
    string lystr2str(const LyStr &lystr);
    string hostname, username, password;
    bool status;
    unsigned int usernumber;
    Connection  * conn;
    Session     * session;
    Unread_confs * unread_confs;
};

#endif
