#include "conferenceset.h"


ConferenceSet::ConferenceSet()
{
    active_conference = 0;
}


ConferenceSet::~ConferenceSet()
{
    for (unsigned int i = 0; i < conferences.size(); i++) {
	delete conferences[i];
    }
}


vector< GtkomConference * >
ConferenceSet::getConferences()
{
    return conferences;
}


bool
ConferenceSet::deleteConference(unsigned int conference_id)
{
    bool found = false;
    unsigned int i;
    
    for (i = 0; (i < conferences.size()) && (! found); i++) {
	if (conferences[i]->getConferenceId() == conference_id)
	    found = true;
    }
    
    // Delete found conference. The active conference is the nearest previous. 
    if (found) {
	i--;
	if (active_conference->getConferenceId() == conference_id)
	    active_conference = conferences[(i + 1) % conferences.size()];
	delete conferences[i];
	for ( ; i < (conferences.size() - 1); i++)
	    conferences[i] = conferences[i+1];
	conferences.resize(conferences.size() - 1);
    }
    return found;
}


void
ConferenceSet::addConference(GtkomConference *conference_in)
{
    conferences.push_back(conference_in);
    if (getNumberOfConferences() == 1)
	active_conference = conference_in;
};


GtkomConference *
ConferenceSet::getActiveConference()
{
    return active_conference;
}


bool
ConferenceSet::setActiveConference(unsigned int conference_id)
{
    bool found = false;
    unsigned int i;
    
    for (i = 0; (i < conferences.size()) && (! found); i++) {
	if (conferences[i]->getConferenceId() == conference_id)
	    found = true;
    }
    
    if (found) {
	i--;
	active_conference = conferences[i];
    }
    return found;
}


unsigned int
ConferenceSet::getNumberOfConferences()
{
    return conferences.size();
}


GtkomConference *
ConferenceSet::setNextConference()
{
    bool found = false;
    unsigned int i;
    for (i = 0; (i < conferences.size()) && (! found); i++)
	{
	    if (conferences[i] == active_conference)
		found = true;
	}
    
    if (found) {
	i--;
	active_conference = conferences[(i + 1) % getNumberOfConferences()];
    }  
    return active_conference;
}

