#include "comm.h"
#include "conferenceset.h"
#include "errordialog.h"

extern Comm comm;
extern ConferenceSet *conferenceSet;
extern ControlMainWindow mainwin;


ControlJoinDialog::ControlJoinDialog()
{
    guiObject = new JoinDialog(this);
}


ControlJoinDialog::~ControlJoinDialog()
{
    delete guiObject; 
}


void
ControlJoinDialog::show()
{
    guiObject->show();
}


vector <longstringpair>
ControlJoinDialog::getMatchingConferences(string query)
{
    return comm.getConferences(query, FALSE, TRUE);
}


void
ControlJoinDialog::join(longstringpair conference)
{
  
    vector< GtkomConference * > conferences;
  
    conferences = conferenceSet->getConferences();
    unsigned int size = conferences.size();
    unsigned int i = 0;
    while(1) {
	if (i >= size)
	    break;
	if (conference.first == conferences[i]->getConferenceId()) {
	    ControlErrorDialog felruta;
	    felruta.show(_("You are already a member of this conference."));
	    return;
	}
	i++;
    }
 
    if (comm.joinConference(conference.first)) {  
	GtkomConference *new_conf;
	new_conf = new GtkomConference;
	new_conf->setConferenceId(conference.first);
	new_conf->setName(conference.second);
	  	  
	conferenceSet->addConference(new_conf);
	mainwin.conferenceListAdd(*new_conf);
	guiObject->hide();
      
    }
    else {	  
	ControlErrorDialog felruta;
	felruta.show(_("You are not allowed to join this conference."));
    }
}






