#include "conferenceset.h"

extern ControlMainWindow mainwin;
extern ConferenceSet *conferenceSet;


ControlLeaveDialog::ControlLeaveDialog()
{
    guiObject = new LeaveDialog(this);
}


ControlLeaveDialog::~ControlLeaveDialog()
{
    delete guiObject;
}


void
ControlLeaveDialog::show()
{
    vector< longstringpair > conferences; 
    longstringpair ipair;
    vector< GtkomConference * > confobj = conferenceSet->getConferences();
    unsigned int objsize = confobj.size();
  
    for (unsigned int i = 0; i < objsize; i++) {
	ipair.first = confobj[i]->getConferenceId();
	ipair.second = confobj[i]->getName();
	conferences.push_back(ipair);
    }

    guiObject->show(conferences);
}


void
ControlLeaveDialog::leave(unsigned int conference_id)
{
    if (conference_id == comm.getUserId()) {
	ControlErrorDialog errordialog;
	errordialog.show(_("You may not leave your letterbox conference."));
	return;
    }

    if (!comm.leaveConference(conference_id))
	;
  
    conferenceSet->deleteConference(conference_id);
    if (conferenceSet->getNumberOfConferences() > 0) {
	if (!comm.changeConference(conferenceSet->getActiveConference()->getConferenceId()))
	    ;
    }
 
    // Update conference list
    GtkomConference conf;
    conf.setConferenceId(conference_id);
    conf.setName("");
    mainwin.conferenceListDel(conf);
    guiObject->hide();
  
}




