#include "conferenceset.h"
#include "errordialog.h"


extern ControlMainWindow mainwin;
extern ConferenceSet *conferenceSet;


ControlLoginDialog::ControlLoginDialog()
{
    guiObject = new LoginDialog(this);
}


ControlLoginDialog::~ControlLoginDialog()
{
    delete guiObject;
}


void
ControlLoginDialog::show()
{
    guiObject->show();
}


void
ControlLoginDialog::hide() 
{
    guiObject->hide();
}


void
ControlLoginDialog::login(string hostname,
			  string username,
		          string password)
{
    int result;
    result = comm.login(hostname, username, password);

    vector< longstringpair > conferences;   
    ControlErrorDialog errordialog; 
    pair<unsigned int, string> tmpconf; 

    switch (result)
	{
	case 0:
	    // Login successfull
      
	    guiObject->hide();
      
	    mainwin.appbarStatus(_("Connected to ")+hostname);
	    conferences = comm.getMemberConferences();
	    GtkomConference *new_conference;
	    conferenceSet = new ConferenceSet; 
	    if (conferences[0].first == 0) {
		mainwin.dimForLoggedin();
		break;
	    }
	    for(unsigned int i=0; i < conferences.size(); i++) {
		new_conference = new GtkomConference;
		new_conference->setConferenceId(conferences[i].first);
		new_conference->setName(conferences[i].second);
	      
		conferenceSet->addConference(new_conference);
		mainwin.conferenceListAdd(*new_conference);
	      
		//if (!comm.changeConference(conferences[i].first))
		//	  ;
	    }
      
	    // Sets active conference
	    tmpconf = comm.getNextConference(); 
      
	    conferenceSet->setActiveConference(tmpconf.first);
	    if (!comm.changeConference(tmpconf.first))
		;
	    mainwin.conferenceListSelect(tmpconf.first);      
	    mainwin.dimForLoggedin();
	    break;
	case 1:
	    // Wrong hostname
	    errordialog.show(_("Invalid hostname."));
	    break;
	case 2:
	    // Wrong username
	    errordialog.show(_("Invalid username."));
	    break;
	case 3:
	    // Wrong password
	    errordialog.show(_("Invalid password"));
	    break;
	}
}





