
#include "errordialog.h"
#include <ctime>


ControlMainWindow::ControlMainWindow()
{
    guiObject = new MainWindow(this);
}


ControlMainWindow::~ControlMainWindow()
{
    delete guiObject;
}


void
ControlMainWindow::show()
{
    guiObject->show();
}


void
ControlMainWindow::dimForLoggedin()
{
    guiObject->dim_for_loggedin();
}


void
ControlMainWindow::dimForLoggedout()
{
    guiObject->dim_for_loggedout();
}


void 
ControlMainWindow::appbarStatus(string text)
{
    guiObject->appbarStatus(text);
}


void
ControlMainWindow::conferenceListAdd(GtkomConference aconf)
{
    longstringpair apair;

    apair.first = aconf.getConferenceId();
    apair.second = aconf.getName();

    guiObject->conferencelist_add(apair);
}


void
ControlMainWindow::conferenceListDel(GtkomConference aconf)
{
    guiObject->conferencelist_del(aconf.getConferenceId());
}


void
ControlMainWindow::conferenceListSelect(unsigned int conf_id)
{
    guiObject->conferencelist_select(conf_id);
}


void
ControlMainWindow::conferenceListClear()
{
    guiObject->conferencelist_clear();
}


void
ControlMainWindow::addStringToTextwindow(string text)
{
    guiObject->add_string_to_textwindow(text);
}


void 
ControlMainWindow::addToTextwindow(Article aarticle)
{
    guiObject->add_to_textwindow(aarticle);
}


void
ControlMainWindow::login()
{
    ControlLoginDialog myLoginDialog;

    myLoginDialog.show();
}


void
ControlMainWindow::logout()
{
    ControlLogoutDialog myLogoutDialog;
  
    myLogoutDialog.show();
}


void
ControlMainWindow::exit()
{
    ControlExitDialog exitruta;

    exitruta.show();
    
}


void
ControlMainWindow::join()
{
    ControlJoinDialog joinDialog;

    joinDialog.show();

}


void
ControlMainWindow::leave()
{
    ControlLeaveDialog leaveDialog;

    leaveDialog.show();

}


void
ControlMainWindow::next_conference()  
{
    if (conferenceSet->getNumberOfConferences() > 0) {    
	GtkomConference *conf;
	int i = conferenceSet->getNumberOfConferences();
	int conf_id;
	
	while(1) {
	    i--;
	    
	    conferenceSet->setNextConference();
            conf = conferenceSet->getActiveConference();
	    conf_id = conf->getConferenceId();
	    if (!comm.changeConference(conf_id))
		// This should never happen
		;
	    if (comm.getUnread() > 0) {
		// There are unread articles in this conference
		conferenceListSelect(conf_id);
		break;
	    }
	    if (i == 0) {
		// There are no unread articles
		addStringToTextwindow(_("No more unread articles.\n"));
		break;
	    }
	}
    }
    else
	mainwin.addStringToTextwindow(_("You are not member of any conference.\n"));

}


void
ControlMainWindow::next_unread()  
{
    if (conferenceSet->getNumberOfConferences() > 0) { 
	Article tmparticle;
     
	tmparticle = comm.getNextUnreadArticle();
	currentArticle=tmparticle;
     
	longstringpair tmpsender = tmparticle.getSender();
	longstringpair tmppair = tmparticle.getSender();
   
	if (tmparticle.getArticleId() == 0)
	    if (tmpsender.first == 1) {
		mainwin.addStringToTextwindow(_("Changing to next conference...\n"));
		this->next_conference();
		this->next_unread();
	    }
	    else {
		mainwin.addStringToTextwindow(_("No more unread articles.\n"));
	    }
	else {
	    mainwin.addToTextwindow(tmparticle);
	  	     
	}
    }
    else
	mainwin.addStringToTextwindow(_("You are not member of any conference.\n"));

    string unread_string="foo"; 
    char tmp[80]; 
    sprintf(tmp, "%ld", comm.getUnread()); 
    unread_string=string(_("Number of unread in current conference: ")+string(tmp));
    mainwin.appbarStatus(unread_string);

}


void
ControlMainWindow::set_unread()
{
    ControlSetUnreadDialog unreadDialog;

    unreadDialog.show();
}


void 
ControlMainWindow::write_article()
{
    ControlWriteDialog writeDialog;
    writeDialog.show();
}


void
ControlMainWindow::write_reply()
{
    ControlWriteDialog writeReplyDialog;
    writeReplyDialog.showReply();
}


void
ControlMainWindow::about()
{
    ControlAboutDialog myAboutDialog;
    myAboutDialog.show();
}


void 
ControlMainWindow::conferenceClicked(longstringpair apair)
{
    conferenceSet->setActiveConference(apair.first);
 
    if (!comm.changeConference(apair.first))
	;
    ;

    string unread_string;
    char tmp[80]; 
    sprintf(tmp, "%ld", comm.getUnread()); 
    unread_string = (string) _("Number of unread in current conference: ") + (string) tmp;
    mainwin.appbarStatus(unread_string);

}




