#include "conferenceset.h"
#include "conference.h"

#include "article.h"
#include "errordialog.h" 
#include <string>

extern ConferenceSet *conferenceSet;
extern Article currentArticle;


ControlWriteDialog::ControlWriteDialog()
{
    guiObject = new WriteDialog(this);
}


ControlWriteDialog::~ControlWriteDialog()
{
    delete guiObject;
}


string 
ControlWriteDialog::textReformat(string intext)
{
    unsigned int spacepos = 0;
    unsigned int currentpos = 0;
    unsigned int line_beginning = 0;
    const string space = " ";
    string::iterator it;
    for (it = intext.begin(); it != intext.end(); ++it) {
	currentpos = it - intext.begin();
	if ( !intext.compare(space, currentpos, 1) ) {
	    // We found a space. It's a candidate position for linebreak
	    spacepos = currentpos;
	}

	if ( currentpos > line_beginning + 70) {
	    // We have passed the 70th char. 
	    // If there was a space in this line, break at last space. 
	    if ( spacepos != line_beginning ) {
		intext.replace(spacepos, 1, "\n");
		line_beginning = spacepos + 1;
	    }
	    else {
		// This was a long line, wihout spaces. Break anyway!
		intext.replace(currentpos, 1, "\n");
		line_beginning = currentpos + 1;
	    }
	}
    }
    return intext;
}


void
ControlWriteDialog::show()
{
    string namn = (conferenceSet->getActiveConference())->getName();
    guiObject->show(namn);
}


void 
ControlWriteDialog::write(string header, string text)
{
    // Linebreak article
    text = textReformat(text);
  
    Article my_article; 
    my_article.setHeader(header);
  
  
  
    my_article.setText(text);
  
  
  
    unsigned int conf_id = 
	(conferenceSet->getActiveConference())->getConferenceId();
  
  
    longstringpair rec;
    rec.first=conf_id;
    rec.second=""; 
  
    my_article.setReciever(rec);
    bool ok = comm.sendArticle(my_article);
  
  
}


void
ControlWriteDialog::writeReply(string header, string text, unsigned long int reply_to)
{
    text = textReformat(text);

    Article my_article;
    my_article.setText(text);
    longstringpair comment_to;

    comment_to.first = reply_to;
    comment_to.second = header;
    my_article.setCommentTo(comment_to);
    my_article.setHeader(header);
    
    unsigned int conf_id = 
	(conferenceSet->getActiveConference())->getConferenceId();
    
    longstringpair rec;
    rec.first=conf_id;
    rec.second=""; 
    my_article.setReciever(rec); 
    comm.sendArticle(my_article);
} 


void
ControlWriteDialog::showReply()
{
    string namn = (conferenceSet->getActiveConference())->getName();

    unsigned long int article_id = currentArticle.getArticleId();

    if (article_id==0) {
	ControlErrorDialog felruta;
	felruta.show(_("This is no article. You cannot comment it."));
    }
    else {
	string header = currentArticle.getHeader();
	
	guiObject->show(namn, header, article_id); 
    }
}
