#include "config.h"
#include "leavedialog.h"
#include "mainwindow.h"
#include "comm.h"


extern GtkWidget *topwindow;
extern Comm comm;

#include "controlleavedialog.cc"

ControlLeaveDialog* LeaveDialog::controlObject=0;
GtkWidget* LeaveDialog::window=NULL;
GtkWidget* LeaveDialog::conf_list=NULL;
// -1 means nothing is selected
long int LeaveDialog::selected_row=-1;


LeaveDialog::LeaveDialog(ControlLeaveDialog *creator)
{
    controlObject = creator;
}


LeaveDialog::~LeaveDialog()
{

}


void
LeaveDialog::ok_clicked(GtkWidget *widget,GdkEvent *event,gpointer data)
{
    if (selected_row!=-1)  {
	gchar *conference_number;
	gtk_clist_get_text(GTK_CLIST(conf_list), selected_row, 0,
			   &conference_number);
      
	guint32 conference_number_int;
	conference_number_int = (unsigned int) atol(conference_number);
      
	controlObject->leave(conference_number_int);
    }
    else
	;
}


void
LeaveDialog::selection_made(GtkWidget      *clist,
			    gint            row,
			    gint            column,
			    GdkEventButton *event,
			    gpointer        data )
{
    selected_row=row;
}


void
LeaveDialog::hide()
{
    gtk_widget_destroy(window);
}


void
LeaveDialog::show(vector< longstringpair > conference_list)
{
    selected_row=-1;

    window = gnome_dialog_new(
			      _("Leave conference"),
			      GNOME_STOCK_BUTTON_OK,
			      GNOME_STOCK_BUTTON_CANCEL,
			      NULL);

    gtk_window_set_default_size(GTK_WINDOW(window),500,500);
  
    gtk_window_set_policy(GTK_WINDOW(window),FALSE,TRUE,TRUE);  

    gtk_window_set_modal(GTK_WINDOW(window),TRUE);

    label=gtk_label_new(_("Select the conference you want to leave"));
  
    gtk_box_pack_start (GTK_BOX (GNOME_DIALOG (window)->vbox),
			label, FALSE,FALSE, 0);
    gtk_widget_show(label);
  
    // A scrolled window
    scroll_win = gtk_scrolled_window_new (NULL, NULL);
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scroll_win),
				    GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  
    gtk_box_pack_start(GTK_BOX (GNOME_DIALOG (window)->vbox), 
		       scroll_win, TRUE, TRUE, 0);
    gtk_widget_show (scroll_win);
    
    // Titles
    gchar *titles[2] = { 
	"Conference number dummy", 
	"Member conferences dummy" 
    };
    titles[0] = _("Conference number");
    titles[1] = _("Member conferences");

    conf_list = gtk_clist_new_with_titles(2, titles);
  
    gtk_clist_set_selection_mode(GTK_CLIST(conf_list), GTK_SELECTION_SINGLE);
  
    gtk_clist_column_titles_passive(GTK_CLIST(conf_list));
  
    gtk_clist_set_column_visibility(GTK_CLIST(conf_list), 0, FALSE);
  
    gtk_clist_set_column_auto_resize(GTK_CLIST (conf_list),
				     1,
				     TRUE);
    
    gtk_container_add(GTK_CONTAINER(scroll_win),conf_list);
  
    gtk_widget_show(conf_list);
  

    // OK button as default
    gnome_dialog_set_default (GNOME_DIALOG(window),0);
  
    // Connect OK
    gnome_dialog_button_connect
	(GNOME_DIALOG( window),0,
	 GTK_SIGNAL_FUNC(LeaveDialog::ok_clicked)
	 ,NULL); 
    	 
    gnome_dialog_button_connect_object
	(GNOME_DIALOG(window),1,
	 GTK_SIGNAL_FUNC(gtk_widget_destroy),
	 GTK_OBJECT(window));


    // Connect select
    gtk_signal_connect(GTK_OBJECT(conf_list), "select_row",
		       GTK_SIGNAL_FUNC(LeaveDialog::selection_made),
		       NULL);
  

    gnome_dialog_set_parent(GNOME_DIALOG(window),GTK_WINDOW(topwindow));
  
    gtk_widget_show(window);
  
    gtk_clist_freeze(GTK_CLIST(conf_list));

    // Fill with data
    int length_of_vector=conference_list.size();
    gchar *row_text[2];
    char tmp[80]; 
  
    for(int i=0;i<length_of_vector;i++ ) {
	// Conference name
	row_text[1]= (gchar *) (conference_list[i].second).c_str();
      
	// Conference number
	sprintf(tmp, "%u", conference_list[i].first); 
	row_text[0]= (gchar *) tmp;
	gtk_clist_append(GTK_CLIST(conf_list),row_text);
    }
  
    // Autosort
    gtk_clist_set_sort_column(GTK_CLIST(conf_list),1); 
    gtk_clist_set_sort_type(GTK_CLIST(conf_list),GTK_SORT_ASCENDING);
    gtk_clist_sort(GTK_CLIST(conf_list));
  

    gtk_clist_thaw(GTK_CLIST(conf_list));
  
}



