#include "config.h"
#include "logindialog.h"
#include "mainwindow.h"
#include "comm.h"
#include "conference.h"

extern GtkWidget *topwindow;
extern Comm comm;
extern ControlMainWindow mainwin;


#include "controllogindialog.cc"

ControlLoginDialog* LoginDialog::controlObject=0;
GtkWidget* LoginDialog::window=NULL;
GtkWidget* LoginDialog::input1=NULL;
GtkWidget* LoginDialog::input2=NULL;
GtkWidget* LoginDialog::input3=NULL;


LoginDialog::LoginDialog(ControlLoginDialog *creator)
{
    controlObject = creator;
}


LoginDialog::~LoginDialog()
{

}


void
LoginDialog::ok_clicked(GtkWidget *widget,GdkEvent *event,gpointer data)
{
    controlObject->login((string)gtk_entry_get_text(GTK_ENTRY(input1)),
			 (string)gtk_entry_get_text(GTK_ENTRY(input2)),
			 (string)gtk_entry_get_text(GTK_ENTRY(input3)));
}


void
LoginDialog::show()
{
    window = gnome_dialog_new(
			      _("Login"),
			      GNOME_STOCK_BUTTON_OK,
			      GNOME_STOCK_BUTTON_CANCEL,
			      NULL);
    gtk_window_set_modal(GTK_WINDOW(window),TRUE);
  
    // A table with entries
    table = gtk_table_new(3,3,TRUE);
    gtk_table_set_row_spacings (GTK_TABLE(table),4);
    gtk_table_set_col_spacings (GTK_TABLE(table),4);
    gtk_box_pack_start (GTK_BOX (GNOME_DIALOG (window)->vbox),
			table, TRUE, FALSE, 0);
    gtk_widget_show(table);
  
    label = gtk_label_new (_("Server"));
    gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,0,1);
    gtk_widget_show(label);
  
    input1=gtk_entry_new();
    gtk_table_attach_defaults(GTK_TABLE(table),input1,1,3,0,1);
    gtk_entry_set_text(GTK_ENTRY(input1),"kom.lysator.liu.se");
    gtk_widget_show(input1);
  
    label = gtk_label_new (_("Username"));
    gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,1,2);
    gtk_widget_show(label);
  
    input2=gtk_entry_new();
    gtk_table_attach_defaults(GTK_TABLE(table),input2,1,3,1,2);
    gtk_widget_show(input2);
  
    label = gtk_label_new (_("Password"));
    gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,2,3);
    gtk_widget_show(label);
  
    input3=gtk_entry_new();
    // Make password appear in stars
    gtk_entry_set_visibility(GTK_ENTRY(input3),FALSE);
    gtk_table_attach_defaults(GTK_TABLE(table),input3,1,3,2,3);
    gtk_widget_show(input3);
  
    gnome_dialog_set_default (GNOME_DIALOG(window),0);

    // Make sure Enter gives OK
    gnome_dialog_editable_enters(GNOME_DIALOG(window),GTK_EDITABLE(input1));
    gnome_dialog_editable_enters(GNOME_DIALOG(window),GTK_EDITABLE(input2));
    gnome_dialog_editable_enters(GNOME_DIALOG(window),GTK_EDITABLE(input3));

    // Connect OK
    gnome_dialog_button_connect
	(GNOME_DIALOG( window),0,
	 GTK_SIGNAL_FUNC(LoginDialog::ok_clicked)
	 ,NULL); 
  
  
    // Connect destroy
    gnome_dialog_button_connect_object
	(GNOME_DIALOG(window),1,
	 GTK_SIGNAL_FUNC(gtk_widget_destroy),
	 GTK_OBJECT(window));
  
    gnome_dialog_set_parent(GNOME_DIALOG(window),GTK_WINDOW(topwindow));

    gtk_widget_grab_focus(GTK_WIDGET(input2));

    gtk_widget_show(window);
}


void
LoginDialog::hide()
{
    gnome_dialog_close(GNOME_DIALOG(window));
}









