#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <config.h>
#include <iostream.h>
#include <gnome.h>
#include <gdk/gdkkeysyms.h>
#include "conference.h"
#include "article.h"
#include <utility>
#include "common.h"

class MainWindow;

#include "controlmainwindow.h"


class MainWindow
{
public:
    MainWindow(ControlMainWindow *creator);
    ~MainWindow();

    // FIXME: The method names should not use underscores

    void show();
    void appbarStatus(string text);
    void install_menus_and_toolbar(GtkWidget* app);

    // Dim menus
    void dim_for_loggedin();
    void dim_for_loggedout();

    // Management of conferencelist
    void conferencelist_add(longstringpair apair);
    void conferencelist_del(unsigned int conf_num);
    void conferencelist_clear();
    void conferencelist_select(unsigned int conf_num);
    static void conference_clicked(GtkWidget      *clist,
				      gint            row,
				      gint            column,
				      GdkEventButton *event,
				      gpointer        data);
    GtkWidget* conferencelist_create();

    // Read window
    void add_to_textwindow(Article article);
    void add_string_to_textwindow(string text);
		      
    // Menu-Callbacks
    static void key_press_cb(GtkWidget *widget, GdkEventKey *event);
    static void nothing_cb (GtkWidget* widget, gpointer data);
    static void login_cb (GtkWidget* widget, gpointer data);
    static void logout_cb (GtkWidget* widget, gpointer data);
    static void exit_cb (GtkWidget* widget, gpointer data);
    static void join_cb (GtkWidget* widget, gpointer data);
    static void leave_cb (GtkWidget* widget, gpointer data);
    static void next_conference_cb (GtkWidget* widget, gpointer data);
    static void next_unread_cb (GtkWidget* widget, gpointer data);
    static void set_unread_cb (GtkWidget* widget, gpointer data);
    static void write_article_cb (GtkWidget* widget, gpointer data);
    static void write_reply_cb (GtkWidget* widget, gpointer data);
    static void about_cb (GtkWidget* widget, gpointer data);
private:
    GtkWidget *button;
    GnomeAppBar *appbar;
    static ControlMainWindow* controlObject;
    static GtkWidget *conf_list;
    GtkWidget *textwindow;
    GtkWidget *scrolled_window_right;
    void color_add(const char *addtext, GdkColor *fore);
    void add_elisp_accelerators(GtkWidget* app);
};



#endif


