#include "config.h"
#include "writedialog.h"
#include "mainwindow.h"
#include "comm.h"


extern GtkWidget *topwindow;
extern Comm comm;


#include "controlwritedialog.cc"

ControlWriteDialog* WriteDialog::controlObject=0;
GtkWidget* WriteDialog::window=NULL;
GtkWidget* WriteDialog::input_text=NULL;
GtkWidget* WriteDialog::input_subject=NULL;
GtkWidget* WriteDialog::input_reciever=NULL;
GtkWidget* WriteDialog::input_comment=NULL;


WriteDialog::WriteDialog(ControlWriteDialog *creator)
{
    controlObject = creator;
}


WriteDialog::~WriteDialog()
{

}


void
WriteDialog::ok_clicked(GtkWidget *widget,GdkEvent *event,gpointer data)
{
    guint32 comment_int;
    comment_int = 
	(unsigned long int) atol(gtk_entry_get_text(GTK_ENTRY(input_comment)));
  
    if(comment_int != 0) { 
	// Writing comment
	controlObject->writeReply
	    (gtk_entry_get_text(
				GTK_ENTRY(input_subject)),
	     gtk_editable_get_chars(GTK_EDITABLE(input_text),
				    0,-1),
	     comment_int);
	  
	  
    }
    else {
	// Writing new article
	controlObject->write(
			     gtk_entry_get_text(
						GTK_ENTRY(input_subject)),
			     gtk_editable_get_chars(GTK_EDITABLE(input_text),
						    0,-1));
	  
    }	       
}


void
WriteDialog::show(string conference_name,string subject,
		  unsigned long int message_nr )
{
    window = gnome_dialog_new(
			      "",
			      GNOME_STOCK_BUTTON_OK,
			      GNOME_STOCK_BUTTON_CANCEL,
			      NULL);
    gtk_window_set_modal(GTK_WINDOW(window),TRUE);
  
    string title;
    if (message_nr !=0)
	title = _("Comment on article");
    else
	title = _("Write article");
  
    gtk_window_set_title(GTK_WINDOW(window),title.c_str()); 
  
    gtk_window_set_policy(GTK_WINDOW(window),FALSE,TRUE,TRUE);  
  
    gtk_window_set_default_size(GTK_WINDOW(window),500,500);
  
    table=gtk_table_new(4,4,FALSE);
  
    scroll_win=gtk_scrolled_window_new(NULL,NULL);
  
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scroll_win),
				    GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  
    label=gtk_label_new(_("Subject"));
    label2=gtk_label_new(_("Recipient"));
    label3=gtk_label_new(_("Comment to article"));
  
    input_comment=gtk_entry_new();
    input_subject=gtk_entry_new();
    input_reciever=gtk_entry_new();
    input_text=gtk_text_new(NULL,NULL);
  
    gtk_entry_set_editable(GTK_ENTRY(input_comment),FALSE);
    gtk_entry_set_editable(GTK_ENTRY(input_reciever),FALSE);

    char tmp[80]; 
    sprintf(tmp, "%lu", message_nr);

    gtk_entry_set_text(GTK_ENTRY(input_comment),tmp);
    gtk_entry_set_text(GTK_ENTRY(input_reciever),conference_name.c_str());
    gtk_entry_set_text(GTK_ENTRY(input_subject),subject.c_str());
  
    gtk_text_set_editable(GTK_TEXT(input_text),TRUE);

    gtk_text_set_word_wrap(GTK_TEXT(input_text),TRUE);

    gtk_box_pack_start(GTK_BOX (GNOME_DIALOG (window)->vbox),
		       table,TRUE,TRUE,0);
  
    gtk_container_add(GTK_CONTAINER(scroll_win),input_text);
  
    gtk_table_set_row_spacing(GTK_TABLE(table),0,5);
    gtk_table_set_row_spacing(GTK_TABLE(table),1,5);
    gtk_table_set_row_spacing(GTK_TABLE(table),2,5);
  

    gtk_table_attach (GTK_TABLE(table),label , 0, 1, 2, 3,
		      GtkAttachOptions(GTK_FILL | GTK_EXPAND),
		      GtkAttachOptions(0), 0, 0);
    gtk_table_attach (GTK_TABLE(table), input_subject, 1, 4, 2, 3,
		      GtkAttachOptions(GTK_FILL | GTK_EXPAND),
		      GtkAttachOptions(0), 20, 0); 

    gtk_table_attach (GTK_TABLE(table),label2 , 0, 1, 1, 2,
		      GtkAttachOptions(GTK_FILL | GTK_EXPAND),
		      GtkAttachOptions(0), 0, 0);
    gtk_table_attach (GTK_TABLE(table), input_reciever, 1, 4, 1, 2,
		      GtkAttachOptions(GTK_FILL | GTK_EXPAND),
		      GtkAttachOptions(0), 20, 0); 

    gtk_table_attach (GTK_TABLE(table),label3 , 0, 1, 0, 1,
		      GtkAttachOptions(GTK_FILL | GTK_EXPAND),
		      GtkAttachOptions(0), 0, 0);
    gtk_table_attach (GTK_TABLE(table), input_comment, 1, 4, 0, 1,
		      GtkAttachOptions(GTK_FILL | GTK_EXPAND),
		      GtkAttachOptions(0), 20, 0); 

    gtk_table_attach (GTK_TABLE(table), scroll_win, 0, 4, 3, 4,
		      GtkAttachOptions(GTK_FILL | GTK_EXPAND),
		      GtkAttachOptions(GTK_FILL | GTK_EXPAND), 0, 0);
  
    // Show all widgets
    gtk_widget_show(table);
    gtk_widget_show(scroll_win);
    gtk_widget_show(label);
    gtk_widget_show(label2);
    gtk_widget_show(input_subject);
    gtk_widget_show(input_text);
    gtk_widget_show(input_reciever);
  
  
    if (message_nr!=0) {
	gtk_widget_show(label3);
	gtk_widget_show(input_comment);
    }
  
    // OK as default
    gnome_dialog_set_default (GNOME_DIALOG(window),0);
  
    
    // Connect OK
    gnome_dialog_button_connect
	(GNOME_DIALOG( window),0,
	 GTK_SIGNAL_FUNC(WriteDialog::ok_clicked)
	 ,NULL); 
  
    gnome_dialog_button_connect_object
	(GNOME_DIALOG(window),1,
	 GTK_SIGNAL_FUNC(gtk_widget_destroy),
	 GTK_OBJECT(window));
  
    gnome_dialog_button_connect_object
	(GNOME_DIALOG(window),0,
	 GTK_SIGNAL_FUNC(gtk_widget_destroy),
	 GTK_OBJECT(window));

    gnome_dialog_set_parent(GNOME_DIALOG(window),GTK_WINDOW(topwindow));
  
    gtk_widget_grab_focus(GTK_WIDGET(input_subject));
        
    gtk_widget_set_sensitive(GTK_WIDGET(input_reciever),FALSE);
    gtk_widget_set_sensitive(GTK_WIDGET(input_comment),FALSE);
    
    gtk_widget_show(window);
}

